#!/bin/bash
-
# Desc: Template to check that apps, files, or dirs exist.
-# Author: Steven Baltaktei Sandoval
-# License: GPLv3+
+# Author: Steven Baltaktei Sandoval; License: GPLv3+
#==BEGIN Define script parameters==
#===BEGIN Declare local script functions===
+yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
+die() { yell "$*"; exit 111; }
+try() { "$@" || die "cannot $*"; }
timeUntilMidnight(){
# Desc: Report seconds until midnight
- # Output: stdout: seconds until midnight
+ # Output: stdout: integer seconds until midnight
+ # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
+ # Usage: timeUntilMidnight
+ # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi
+ local returnState
TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
DATE_CURRENT="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
DATE_TOMORROW="$(date -d "$TIME_CURRENT next day" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
TIME_NEXT_MIDNIGHT="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second).
SECONDS_UNTIL_NEXT_MIDNIGHT="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
- echo "$SECONDS_UNTIL_NEXT_MIDNIGHT" 2>/dev/null;
+ if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then
+ returnState="true";
+ elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then
+ returnState="WARNING_ZERO";
+ yell "WARNING:Reported time until midnight exactly zero.";
+ elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then
+ returnState="WARNING_NEGATIVE";
+ yell "WARNING:Reported time until midnight is negative.";
+ fi
+
+ try echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report
+
+ #===Determine function return code===
+ if [[ "$returnState" = "true" ]]; then
+ return 0;
+ elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+ return 1;
+ elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+ return 2;
+ fi
} # Report seconds until next midnight
#===END Declare local script functions===
#==END Define script parameters==
#==BEGIN sample code==
-echo "Time until next midnight (seconds):$(timeUntilMidnight)"
+try echo "Time until next midnight (seconds):$(timeUntilMidnight)" # simple report
+
+if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
#==END sample code==